#if defined _stamm_included
  #endinput
#endif
#define _stamm_included

// For more Infos: http://pup-board.de/index.php?page=Thread&postID=7773

/**
 * Execute when a player becomes VIP
 *
 * @param client		Client.
 * @noreturn
 */
forward OnClientBecomeVip(client);

/**
 * Execute when a player gets Stamm Points
 *
 * @param client		Client.
 * @param number		The number of points, the player gets.
 * @noreturn
 */
forward OnClientGetStammPoints(client, number);

/**
 * Return the Number of Points of a player
 *
 * @param client		Client.
 * @return				Points of Player or -1 on error.
 * @error				Client is invalid, BOT or not connected!
 */
 
native GetClientStammPoints(client);

/**
 * Return how much Points a player need for a specific Level
 *
 * @param type			0 = Normal VIP, 1 = Bronze, 2 = Silver, 3 = Gold, 4 = Platinum.
 * @return				How much Points a Client needs, or -1 on Error.
 * @error				Stamm Level is OFF and type not normal vip.
 */
 
native GetStammLevels(type);

/**
 * Return how to get Points
 *
 * @return				0 = Error, 1 = Kills, 2 = Rounds, 3 = Time.
 */
 
native GetStammType();

/**
 * Set Points of a player
 *
 * @param client		Client.
 * @param number		Number of Points to set.
 * @noreturn
 * @error				Client is invalid, BOT or not connected! Invalid number!
 */
 
native SetClientStammPoints(client, number);

/**
 * Add Points to a player
 *
 * @param client		Client.
 * @param number		Number of Points to add.
 * @noreturn
 * @error				Client is invalid, BOT or not connected! Invalid number!
 */
 
native AddClientStammPoints(client, number);

/**
 * Delete Points from a player
 *
 * @param client		Client.
 * @param number		Number of Points to delete.
 * @noreturn
 * @error				Client is invalid, BOT or not connected! Invalid number!
 */
 
native DelClientStammPoints(client, number);

/**
 * Return true when the specific player is VIP, otherwise false
 *
 * @param client		Client.
 * @param type			0 = normal VIP, 1 = Bronze, 2 = Silver, 3 = Gold, 4 = Platinum.
 * @param min			true = Minimum rang, false = Exact Rang.
 * @return				true if Client is VIP, otherwise false.
 * @error				Client is invalid, BOT or not connected! Stamm Level is OFF.
 */
 
native bool:IsClientVip(client, type, bool:min=true);

/**
 * Return true when Stamm Level is ON, otherwise false
 *
 * @return				true if Stamm Level is on, otherwise false.
 */
 
native bool:IsStammLevelOn();